//+------------------------------------------------------------------+
//|                                                          ct4.mq4 |
//|                                     Copyright  2008, CrazyTrain |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, CrazyTrain"
#property link      ""
//   -  ,           ,
//          .
//         ,   .

//_______________________________________________________________________________________________________________

//---- input parameters
extern int       iMAperiod=18;
extern int       iMAshift=0;
extern int       iMAmode=0;
extern int       iMApricetypeUP=2;
extern int       iMApricetypeDN=3;
extern int       TotalTryes=5;
extern double    dbLotsQ=0.5;
/*
PRICE_CLOSE 0   
PRICE_OPEN 1   
PRICE_HIGH 2   
PRICE_LOW 3   
PRICE_MEDIAN 4  , (high+low)/2 
PRICE_TYPICAL 5  , (high+low+close)/3 
PRICE_WEIGHTED 6   , (high+low+close+close)/4 
*/

extern int       iTP_up=0;
extern int       iSL_up=90;
extern bool      bUpOrders=true;

extern int       iTP_dn=0;
extern int       iSL_dn=90;
extern bool      bDnOrders=true;


//      -       .
//#include <Lite_EXPERT1.mqh>
//   __________________________________________________________
int iMagicNumber=123;
int expertBars; //        ,
//      ,     
bool Trade=true;
string ErrorFileName; //  ,    ,      .
string ErrRecString; //          .

// ________________________________________________________________________________
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    if(!IsTradeAllowed())
      {
        Print("  !");
        return(0);     
      }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
// start()       , 
//  ,    start()     5 ,    5    
//  ,  , - ?
//----

//    _______________________

double MAValueUP;
double MAValueDN;
double dMAHigh;
   
Print("  .",Symbol());
ErrorFileName="Error " + Day()+ " " + Month() + " " + Year()+".csv";

//      MAValueUP = iMA(Symbol(),PERIOD_M15,iMAperiod,iMAshift,iMAmode,iMApricetypeUP,0);
//      dMAHigh=iMA(NULL,PERIOD_M15,iMAperiod,0,MODE_SMA,PRICE_HIGH,0);
      //     ?
      //  -    BUY
//      Print("    = ",MAValueUP," ;    =",Close[1]);
      

      
//       ,       -  
if (isNewBar())
{
Print("    !!! !!!");
//___________________________________________________________
//11-11-08         

   //        ?
   if (bUpOrders)
      {
      //    
      //MAValueUP = iMA(Symbol(),PERIOD_M15,iMAperiod,iMAshift,iMAmode,iMApricetypeUP,1);
      MAValueDN = iMA(Symbol(),PERIOD_M15,iMAperiod,iMAshift,iMAmode,iMApricetypeDN,1);
      //     ?
      //  -    BUY
      Print("  !     = ",MAValueUP," ;    =",Close[1]);
      //if(MAValueUP<=Close[1])
      if(MAValueDN>=Close[1])
         {
         OpenBuyPosition();
         }//if(MAValueUP>Close(1))
      }//if (bUpOrders)

   //        ?
   if (bDnOrders)
      {
      //    
      //MAValueDN = iMA(Symbol(),PERIOD_M15,iMAperiod,iMAshift,iMAmode,iMApricetypeDN,1);
      MAValueUP = iMA(Symbol(),PERIOD_M15,iMAperiod,iMAshift,iMAmode,iMApricetypeUP,1);
      //     ?
      //  -    SELL   
      Print("    = ",MAValueUP," ;    =",Close[1]);
      //if(MAValueDN>=Close[1])
      if(MAValueUP<=Close[1])
         {
         OpenSellPosition();
         }//if(MAValueUP>Close(1))
      }//if (bDnOrders)
      
      
} //if (isNewBar())     
   
//----
   return(0);
}
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//|  true    ,  false             |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//----
Print("    ? ",expertBars, "  != ",Bars  );
   bool res=false; 
   if (expertBars!=Bars) 
      {
      expertBars=Bars;
      res=true;
      } 
   return(res);   
   }   
//----  bool isNewBar()__________________________________________________________

//+------------------------------------------------------------------+
//|       BUY                       |
//+------------------------------------------------------------------+
void OpenBuyPosition()
{
//       ,  ,     
//              
   switch (CheckLastPosition("buying"))
   {
   case 0:
      Print("  -   ");
      CreatePosition("buying");
      break;

   case 2:
      Print(" ,  ");
      if(ClosePosition("selling"))
         {
         CreatePosition("buying");
         }
      break;

   case 1:
      Print("  ");
      break;

   case 3:
      Print("  -  ");
      break;
   
   }
}
//+------------------------------------------------------------------+
//|       SELL                      |
//+------------------------------------------------------------------+
void OpenSellPosition()
{
//       ,  ,     
//              
   switch (CheckLastPosition("selling"))
   {
   case 0:
      Print("  -   ");
      CreatePosition("selling");
      break;

   case 2:
      Print(" ,  ");
      if(ClosePosition("buying"))
         {
         CreatePosition("selling");
         }
      break;

   case 1:
      Print("  ");
      break;

   case 3:
      Print("  -  ");      
      break;

   }

}//_______________________________________________________________________________________________________________

//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
//   
// 0 -   
// 1 -      ,     (  ,   )
// 2 -     ,  ,    
// 3 -   ,        -   .
//       
//_____________________________________________________________________________________________

int CheckLastPosition(string strCheckPos)
{
int iQBuyOrders;
int iQSellOrders;

//    - ,   -      (    )
   if (OrdersTotal()==0)
      {
      Print("  ,  !");
      return(0);   
      }

//      ()     
   for (int count=OrdersTotal()-1;count>=0;count--)
      {
      if (OrderSelect(count,SELECT_BY_POS,MODE_TRADES))
         {
         if(OrderSymbol()!=Symbol()) continue;
         if(OrderType()==OP_BUY) iQBuyOrders++;
         if(OrderType()==OP_SELL) iQSellOrders++;
         }
      }
           
//         , 
//         ,   
//      .
   if ((iQBuyOrders + iQSellOrders)>=2)
      {
      return(3);
      }
      
//            
   if (strCheckPos=="buying")
      {
      if (iQBuyOrders==1) 
         {
         Print("  " ,iQBuyOrders, "   ,    ");
         return(1);
         }
      else if (iQSellOrders==1)
         {
         Print("    ,      ");
         return(2);
         }   
      }
   if (strCheckPos=="selling")
      {
      if (iQSellOrders==1) 
         {
         Print("  " ,iQSellOrders, "   ,    ");
         return(1);       
         }
      else if (iQBuyOrders==1)
         {
         Print("    ,      ");
         return(2);
         }   
      }

}//   int CheckLastPosition(string strCheckPos)
//__________________________________________________________________________________________________________________

//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
bool ClosePosition(string strCloseDirection)
{
int ticket;
int iCloseDirection;
double dbClosePrice;
color ArrowColor;
string OpderPrice, strSymb = Symbol(); 
int iMagicNumber=123;
int total = OrdersTotal(); 
int iTryes=0; //   
int err=0;  //      .


   if (strCloseDirection=="buying")
      {
      iCloseDirection=OP_BUY;
      dbClosePrice= MarketInfo(strSymb, MODE_BID);
      ArrowColor=OrangeRed;
      } 
   else if(strCloseDirection=="selling")
      {
      iCloseDirection=OP_SELL;
      dbClosePrice= MarketInfo(strSymb, MODE_ASK);
      ArrowColor=Lime;
      }
   else 
      {
      return(false);
      } 
      
      
   for(int pos=total-1;pos>=0;pos--)                                                                 
     {
      if (OrderSelect(pos, SELECT_BY_POS))
         if (OrderMagicNumber() == iMagicNumber)
                                if ((OrderType()== iCloseDirection)&&(OrderSymbol()==strSymb))
                                                 break;
      if (pos == 0)
               return(false);
     }
     
   ticket=OrderTicket(); 
   
while (iTryes<TotalTryes)
{  
   iTryes++;   
   RefreshRates();
   if (strCloseDirection=="buying")
      {
      dbClosePrice= MarketInfo(strSymb, MODE_BID);
      } 
   else if(strCloseDirection=="selling")
      {
      dbClosePrice= MarketInfo(strSymb, MODE_ASK);
      }
   else 
      {
      return(false);
      } 
      
   if(OrderClose(ticket, dbLotsQ, dbClosePrice, 3, ArrowColor))
     {

       //dbClosePrice = DoubleToStr(OrderClosePrice(), Digits);  
       Print(StringConcatenate(strSymb, iCloseDirection, "    ",
                       ticket, "    ", OrderMagicNumber(), 
                                             "    ", dbClosePrice));
       //----
       return(true);
     }
   else 
     {
       Print(StringConcatenate("   ", strSymb, 
          iCloseDirection,"    ", ticket, "    ", 
                                                         iMagicNumber, "!!!"));
       //----             
       //  
        ErrRecString=strSymb+";"+strCloseDirection+";"+dbClosePrice+";"+OrderTicket()+";"+iMagicNumber+";"+TimeCurrent();
        err = ErrorBlock();
        //  
        if(err > 1)
          {
            Print("    ",
                  OrderTicket());
            return(false);
          }
       //----
         Sleep(5000);
     }
}

Print("   - " ,iTryes,"          ");
return(false);
}// bool ClosePosition(string strCloseDirection)
//______________________________________________________________________________________________________

//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
bool CreatePosition(string strOpenDirection)
{
int ticket;
int iOpenDirection;
double dbOpenPrice;
color ArrowColor;
string OpderPrice, strSymb = Symbol(); 
int iTryes=0;
int err=0;
double dbPoint =MarketInfo(strSymb,MODE_POINT);
int    iDigits=MarketInfo(strSymb,MODE_DIGITS);
double dbSL;

   if (strOpenDirection=="buying")
      {
      iOpenDirection=OP_BUY;
      ArrowColor=Lime;
      } 
   else if(strOpenDirection=="selling")
      {
      iOpenDirection=OP_SELL;
      ArrowColor=OrangeRed;
      }
   else 
      {
      return(false);
      } //if (strOpenDirection=="buying")
      
   //     
   while (iTryes<TotalTryes)
   {  
      iTryes++;   
   //    
      RefreshRates();

   //          

      if (strOpenDirection=="buying")
         {
         dbOpenPrice=MarketInfo(strSymb, MODE_ASK);
         dbSL=dbOpenPrice-NormalizeDouble(iSL_up*dbPoint,iDigits);
         } 
      else if(strOpenDirection=="selling")
         {
         dbOpenPrice=MarketInfo(strSymb, MODE_BID);
         dbSL=dbOpenPrice+NormalizeDouble(iSL_dn*dbPoint,iDigits);
         }
      else 
         {
         return(false);
         } //if (strOpenDirection=="buying")
   
     ticket = OrderSend(strSymb,iOpenDirection,dbLotsQ,dbOpenPrice,3,dbSL,0,NULL,iMagicNumber,0,ArrowColor);
  
   //      
     if(ticket > 0)
      {
        if (OrderSelect(ticket, SELECT_BY_TICKET))
          {
            OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
            Print(StringConcatenate(strSymb, " BUY    ",
                   ticket, "    ", OrderMagicNumber(), 
                                            "    ",OpderPrice));
            return(true);
          }
        else
          {
            Print(StringConcatenate("       ", strSymb, 
               "    ", iMagicNumber, "!!!"));
            return(true);
          }//(OrderSelect(ticket, SELECT_BY_TICKET))
       }
     else
       {
       ErrRecString=strSymb+";"+strOpenDirection+";"+dbOpenPrice+";"+OrderTicket()+";"+iMagicNumber+";"+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
       err=ErrorBlock();
        // Print(StringConcatenate("   ", strSymb, " BUY     ", iMagicNumber, "!!!"));
          if(err > 1)            
          return(0);   
       }//if(ticket > 0)
       Sleep(5000);
   }//while    

Print("   - " ,iTryes,"          ,  ");
return(true);

}// bool CreatePosition(string strOpenDirection)
//___________________________________________________________________________________________________



//+------------------------------------------------------------------+
//| // 0- , 1-   , 2- ,   |
//|    3-                                             |
//+------------------------------------------------------------------+
//   
int ErrorBlock()
  {
   int err = GetLastError();
   
   if (err>0)
      {
      ErrRecString=ErrRecString+";"+err; //    
      ErrorFileCSVWrite(ErrRecString,ErrorFileName);
      }
      
   switch(err)
     {
       case 0: return(0);
       case 2:
         {
           Print(" .  / ");
           Trade = false;
           return(3);  
         }
       case 3:
         {
           Print("   ");
           Trade = false;
           return(3);   
         }
       case 4:
         {
           Print("  .  2 ");
           Sleep(120000);
           return(2);   
         }
       case 6:
         { 
           bool connect = false;
           int iteration = 0;
           Print("Disconnect ");
           while((!connect) || (iteration > 60))
             {
               Sleep(10000);
               Print("  ,  ", iteration*10,
                     "  ");
               connect = IsConnected();
               if(connect)
                 {
                   Print(" ");
                   return(2);
                 }
               iteration++;
             }
           Trade = false; 
           Print("  ");
           return(3);
         }
       case 8:
         {
           Print(" ");
           Trade = false; 
           return(3);
         }
       case 64:
         {
           Print(" !");
           Trade = false; 
           return(3);            
         }
       case 65:
         {
           Print("  ???");
           Trade = false; 
           return(3);            
         }
       case 128:
         {
           Print("   ");
           return(2);
         }
       case 129:
         {
           Print(" ");
           return(1);            
         }
       case 130:
         {
           Print(" ");
           return(1);
         }
       case 131:
         {
           Print("   ");
           Trade = false;            
           return(3);
         }
       case 132:
         {
           Print(" ");
           Trade = false; 
           return(2);
         }
       case 134:
         {
           Print("     ");
           Trade = false;             
           return(2);
         }
       case 135:
         {
           Print(" ");
           return (1);
         }
       case 136:
         {
           Print(" !");
           return(2);
         }
       case 138:
         {
           Print(", !");
           return(1);
         }
       case 139:
         {
           Print("  .  ");
           return(2);
         }
       case 141:
         {
           Print("  ");
           Trade = false; 
           return(2);            
         }
       case 148:
         {
           Print("   ");
           Trade = false; 
           return(2);            
         }                                          
     }
   return (0);
  }
  
  
  //+----------------------------------------------------------------+
//|                    |
//| :                                                       |
//| StringToRec -                                     |
//| FileName -                                      |
//+------------------------------------------------------------------+
void ErrorFileCSVWrite(string StringToRec ,string FileName) 
{
   int handle;
   handle=FileOpen(FileName, FILE_CSV|FILE_READ|FILE_WRITE, ';');
   if(handle>0)
      {
      FileSeek(handle, 0, SEEK_END);
      FileWrite(handle,StringToRec);
      FileClose(handle);
      handle=0;
    }
   return(0);
}//void ErrorFileCSVWrite(string StringToRec ,string FileName) 

